        TITLE Repertoire compl\'ementaire

**********************************************************************
*  (c) 02/1998 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the ERABLE package.
*  This file can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*
*
*  This file is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this file; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
**********************************************************************

INCLUDE erromid.h
INCLUDE erextdec.h
INCLUDE cas2extdec.h
INCLUDE keydefs.h
INCLUDE erhash.h
INCLUDE global.s

* Rpertoire ALGB d'installation
* Ne pas oublier de modifier le checksum dans INIT

ASSEMBLE
        NIBASC /HPHP48-D/
RPL

ASSEMBLE
	CON(5)	=DORRP
	CON(3)	#7FF		( NO LIB attached )
debut	CON(5)	(dernier)-(debut)
	CON(5)	#00000		( le premier objet suit )
RPL


**********************************************************************
* Name:		XFRC
**********************************************************************
ASSEMBLE
	RAMWORD	XFRC
RPL
::
  CK1NOLASTWD
  SETEXACT
  '
  ::
    DUP %ABS DUP
*   NULLNAME FCLIext
    ::
      DTYPEREAL? NcaseTYPEERR
      RCLEPS %>%%
      DUP %%1/
      ROTDUP %>%%
      2DUPSWAP %FLOOR ONE{}N SWAP
      BEGIN			( %%1/eps %x %%error liste %%x-[x]-... )
         DUP %%FLOOR %%-
         DUP 7PICK %%<
         ITE FALSE
	 ::			( %%1/eps %x %%error liste %%x-[x] )
           %%1/ ROTOVER		( ...%x liste %%1/x-[x] %%error  %%1/x-[x] )
           DUP %%* %%1 %%+ %%*
           UNROT		( ...%x, %%error liste %%1/x-[x] )
           5PICK 4PICK %%>
         ;
      WHILE
         DUPUNROT %%FLOOR %%>%
         >TCOMP SWAP
      REPEAT
				( %%eps %%1/eps %x %%error liste %%x-[x] )
      6ROLL  %%<		( %x %%error liste <eps? [-> rationel] )
      ITE
        ::
          UNROT2DROP LIFCext
        ;
        ::
          SWAPDROP DUP LIFCext	( %x, 'p/q' )
          DUP xEVAL		( * crunch ? * )
          4ROLL %- %ABS
          RCLEPS %< IT SWAP
          DROP
        ;
        SWAPDROP
    ;

    DTYPELIST?
    ITE
    ::
      INNERCOMP reversym {}N THREE
      BEGIN
         DUP#0<>
      WHILE
         2DUP ONESWAP SUBCOMP OVER 4PICK SWAPDUP 
         #1+SWAP #2* SUBCOMP OVER EQUAL DUP
         IT
         ::
           DROPOVER 4PICK SWAPDUP #2* #1+SWAP 
           THREE #* SUBCOMP OVER EQUAL
         ;
         DUP IT
         ::
           DROPOVER #1= NOTcase TRUE
           3PICK FOUR NTHCOMPDROP OVER INCOMPDROP %=
         ;
         NOTcase DROP#1-
         UNROTDUP FOUR #* 3PICK
         LENCOMP #1+
         BEGIN
            2DUP#< DUP IT
            ::
              DROP 4PICK 3PICK DUP 6PICK 
              #-+1 SWAP SUBCOMP
              6PICK EQUAL
            ;
         WHILE
            SWAP3PICK #+SWAP
         REPEAT
         DROPSWAP #-+1 MINUSONE SUBCOMP
         INNERCOMP reversym {}N SWAP
         EXACT? UNROT SETEXACT			( ID QU )
         DUPLENCOMP
         ::
           ONE OVER#=case 
           :: DROP INCOMPDROP %CHS %1 SWAP % -1 ;
           TWO OVER#=case 
           :: DROP INCOMPDROP 2DUP %* %CHS SWAP %CHS ;
           THREE OVER#=case 
           :: DROP INCOMPDROP 2DUP %* DUP %1+ %CHS
              5UNROLL 4PICK DUPROT %* %CHS SWAP %-
              OVER %- 3PICK %+ 5UNROLL DROP %* %1+ UNROT
           ;
         ;
         THREE{}POLY  
         NULL{} VXXLext SWAPDROP
         DEG2ext CARCOMP

         ( Fin de QU )

         >TCOMP LIFCext
         SWAP ?SKIP CLREXACT
         ZERO
      REPEAT
      DROP DTYPELIST? ?SKIP SWAP
      DROP
    ;

    SWAPDROP

    SWAP %0< IT RNEGext
    ZEROSWAP NULL{} VAL2ext
  ;
  '
  ::
    CK&DISPATCH1
    real 2GETEVAL
    TWO  :: C%>% 2GETEVAL SWAP 2GETEVAL SWAP C% 0 1 x* x+ ;
    list LISTSECOext
    symb LISTSECOext
    any  NOP
  ;
  2LAMBIND
  1GETLAM EVAL
  CLREXACT
  ABND
;
ASSEMBLE
	RAMWEND	XFRC
RPL

**********************************************************************
* Name:		TEVAL
**********************************************************************
ASSEMBLE
	RAMWORD	TEVAL
RPL
::
  CK1
  GARBAGE
  CLKTICKS 1LAMBIND
  EVAL
  CLKTICKS 1GETABND
  bit-
  HXS>% % 8192 %/ % 0.0067 %- %4 RNDXY
  "s" >TAG
;
ASSEMBLE
	RAMWEND	TEVAL
RPL

**********************************************************************
* Name:		LATEX
**********************************************************************
ASSEMBLE
dernier	RAMWORD	LATEX
RPL
::
  '
  ::				( LAM2 #; STR  STR )
    SWAP DUP#0=csDROP
    DUP#1= casedrop 
      :: "\\left(" SWAP&$ "\\right)" &$ ;
    TWO #=casedrop 
      :: CHR_] >T$ CHR_[ >H$ ;
    THREE #=casedrop 
      :: CHR_} >T$ CHR_{ >H$ ;
    SETSIZEERR
  ;

  '
  ::
    CK&DISPATCH1
    real DO>STR
    cmp  DO>STR
    zint :: CK1Z Z>S ;
    str  NOP
    SIX  ID>$
    symb
    ::
      ' xOBJ\-> EvalNoCK
      SWAP COERCE
      ONE #=casedrop
      ::					( o1; oper )
        SWAP 1GETLAM EVAL
        { xNEG { "-" TRUE ONE }
          xSQ  { "^2" FALSE ONE }
          xINV { "\\frac{1}" TRUE THREE }
        }
        ROTSWAP EQLookup
        ITE
          INCOMPDROP 
          :: DO>STR "\\" SWAP&$ TRUE ONE ;
        4ROLL 2GETEVAL 
        SWAP ITE &$ SWAP&$
      ;
      TWO #=casedrop
      ::					( O1; O2; OPER )
        ROT 1GETLAM EVAL
        ROT 1GETLAM EVAL
        { x+     { "+" TRUE ZERO ZERO }
          x-     { "-" TRUE ONE ZERO }
          x*     { "\\times " TRUE ONE ONE }
          x/     { "\\frac" FALSE THREE THREE }
          x^     { "^" TRUE THREE ZERO }
          xXROOT { "\\sqrt" FALSE TWO THREE }
        }
        4ROLLSWAP EQLookup NcaseSIZEERR
        INCOMPDROP
        6ROLL 2GETEVAL
        5UNROLL 4ROLL 2GETEVAL
        SWAP ?SKIP ROTSWAP &$ &$
      ;
      DROP
      ' x\.S EQUALcasedro
      ::
        1GETLAM EVAL CHR_d >H$ 
        $ "\\int_{" 5ROLL 
        1GETLAM EVAL &$ $ "}^{" &$
        4ROLL 1GETLAM EVAL &$
        CHR_} >T$ ROT 1GETLAM EVAL
        &$ "\\ " &$ SWAP&$
      ;
      xSHALT 
    ; 
  ;
  2LAMBIND
  1GETLAM EVAL
  ABND
;
ASSEMBLE
	RAMWEND	LATEX
RPL
**********************************************************************




