INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE ../CAS/keydefs.h
INCLUDE ../CAS/global.s

**********************************************************************
* Desc:		Check for singularities in expr
* Stack:	( symb inf sup vx -> symb inf sup vx flag )
**********************************************************************
NULLNAME CHECKSING
::					( symb inf sup vx )
  nocareflag TestSysFlag caseFALSE
  3PICK APPROXCOMPEVAL DUPTYPEREAL?	( symb inf sup vx inf ?% )
  NOTcase DROPFALSE
					( symb inf sup vx inf )
  3PICK APPROXCOMPEVAL DUPTYPEREAL?	( symb inf sup vx inf sup ?% )
  NOTcasedrop DROPFALSE
  					( symb inf sup vx inf sup )
  3PICK FALSE 4NULLLAM{} BIND		( symb inf sup vx )
  4PICK SYMBINCOMP 			( symb inf sup vx meta )
  checksing 1GETABND			( symb inf sup vx flag )
;

LABEL checksing
( meta -> )
::
  1GETLAM case NDROP
  DUP#1= case2DROP
  					( meta )
  2GETLAM EQUALPOSMETA			( meta vx # )
  SWAPDROP #0=case NDROP		( -> )
					( meta )
  M1st+case checksing+-*
  M1st-case checksing+-*
  M1st*case checksing+-*
  M1st/case checksing/
  AEQ1stcase xLN checksingLN
  AEQ1stcase xSIGN check0abs
  AEQ1stcase xATAN NDROP
					( meta )
  #1-SWAP enumargs			( meta op # )
  DUP#0=csedrp NDROP			( should not happen )
  DUP #5= case INVALIDOP
					( meta op # )
  SWAPDROP				( meta # )
  ZERO_DO (DO)
    larg checksing
  LOOP
  NDROP
;

LABEL checksing+-*
::
  plDRPpZparg checksing checksing
;

LABEL checksingLN
::
  pulldrop dup			( meta meta )
  checksing			( meta )
  check0			( )
;

LABEL checksing/
::
  plDRPpZparg checksing check0 
;

LABEL check0
( meta -> )
::
  AEQ1stcase xABS check0abs
  switchflag TestSysFlag case check0no
  switchflag SetSysFlag check0no
  switchflag ClrSysFlag
;

LABEL check0no
::
  1GETLAM case NDROP
  CKSYMBN 2GETLAM 			( symb vx )

  DEPTH 1LAMBIND ERRSET 
  ISOLALL
  ERRTRAP checkerr		
  ABND
  CLRCOMPLEX
					( idnt {}_roots )
  SWAPDROP INNERCOMP DUP#0=csDROP
					( meta_roots )
  ZERO_DO (DO)
    checkinbounds
  LOOP
;

LABEL checkerr
::
  DEPTH 1GETLAM #-+1 NDROP NULL{}	( )
;

LABEL checkinbounds
::
  ( * should check for x=k*pi solutions type * )
  APPROXCOMPEVAL DUPTYPEREAL? NOTcaseDROP
  					( % )
  DUP 3GETLAM %< NOTcaseDROP
  4GETLAM %> NOT?SEMI
  TRUE 1PUTLAM
  ISTOP-INDEX #1- NDROP ExitAtLOOP
;

LABEL check0abs
::
  pulldrop check0
;