INCLUDE erextdec.h
INCLUDE cas2extdec.h
INCLUDE erhash.h
INCLUDE keydefs.h
INCLUDE mromid.h
INCLUDE mextdec.h
INCLUDE global.s

**********************************************************************
* EXPORT:
*
**********************************************************************

**********************************************************************
* Desc:
* Stack:	( poly_P irrq-list --> P irrq-list p )
**********************************************************************
NULLNAME FindPrime
::
  OVER CARCOMP ZEROZERO		( P, irrql, lcoef, #prime, # )
  BEGIN
  ::
    DROP #1+
    TABLEPRIME OVER NTHELCOMP
    NcaseSIZEERR		( * hors limite * )
				( P, irrql, lcoef, #p, p )
    #>Z
    3PICKOVER QMODSYMext
    QIsZero?			( P, irrql, lcoef, #p, p, ? p divise lcoef )
    caseFALSE
				( P, irrql, lcoef, #p, p )
    4PICK			( P, irrql, lcoef, #p, p, listirrq )
    DUPNULL{}?
    ::
      case DROPFALSE
      OVER Z1 RSUBext
      Z2 ZQUOText		( P irrql lcoef #p p listirrq [p-1]/2 )
      SWAPDUP			( P irrql lcoef #p p [p-1]/2 Lirrq Lirrq )
      toLEN_DO (DO)
      ::			( P irrql lcoef #p p [p-1]/2 listirrq flag )
        DROPDUP
        INDEX@ NTHCOMPDROP	( P irrql lcoef #p p [p-1]/2 listirrq, irrq )
        DUPTYPEZ? NOTcase DROPTRUE
        3PICK 5PICK ModPow
        Z1 EQUAL		( P irrql lcoef #p p [p-1]/2 lirrq ?carre )
        DUP case ExitAtLOOP
      ;
      LOOP
				( P irrql lcoef #p p [p-1]/2 listirrq flag )
      UNROT2DROP
    ;
				( P irrql lcoef #p p flag )
    caseFALSE			( P irrql lcoef #p p )
    5PICK DUP DERext
    3PICK ModGcd		( P irrql lcoef #p p pgcd[P,P'] )
    Z1 EQUAL 
  ;
  UNTIL
				( P irrql lcoef #p p )
  UNROT2DROP			( P irrql p )
;

**********************************************************************
* Desc:		tableau de nombres premiers p tels que p=3 mod 4
*		 (donc -1 non carre)
* Stack:	( --> {} )
**********************************************************************
NULLNAME TABLEPRIME
{	
  THREE SEVEN ELEVEN NINETEEN TWENTYTHREE THIRTYONE
  FORTYTHREE FORTYSEVEN FORTYNINE # 43
}

* ====================================================================
*			Permutations
* ====================================================================

**********************************************************************
* Desc:		
* Stack:
**********************************************************************
NULLNAME CKPERMext
::
  NOTLISTcase SETTYPEERR
  DUPLENCOMP
  #1+_ONE_DO (DO)
     DUPINDEX@ UNCOERCE
     EQUALPOSCOMP
     #0= IT SETTYPEERR
  LOOP
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME CIRCext
::
  SWAP DUPLENCOMP ROT 
  DUPLENCOMP DUP 4ROLL 
  #= NOT?DIMERR
  #1+_ONE_DO (DO)
     2DUP INDEX@ NTHCOMPDROP
     COERCE NTHCOMPDROP UNROT
  LOOP
  DROP LENCOMP {}N
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME P2Cext
::
  %1 1LAMBIND
  DUPLENCOMP TRUE SWAP
  NDUPN {}N NULL{}			( P DRAPEAU RES )
  BEGIN
     OVER TRUE EQUALPOSCOMP
     DUP#0<>
  WHILE					( P DRAPEAU RES #1ST )
     4PICKSWAP
     2DUP NTHCOMPDROP COERCE		( P DRAPEAU RES P #1ST # )

     ( MISE A JOUR DE DRAPEAU )

     FALSE OVER 7ROLL PUTLIST 5UNROLL

     ( DEBUT DE RESULTAT )

     2DUP UNCOERCE2 
     2DUP EQUAL
     ITE :: DROP ONE{}N ; TWO{}N 	( P DRAPEAU RES P #1ST # {} )
     4ROLLROT				( P DRAPEAU RES 1ST {} P # )
     [BEGIN]
        OVERSWAP NTHCOMPDROP COERCE	( P DRAPEAU RES 1ST {} P # )
        FALSE OVER 8ROLL PUTLIST
        6UNROLL
        DUP 5PICK EQUAL
     NOT_WHILE
     ::					( P DRAPEAU RES 1ST {} P #  )
       ROTOVER UNCOERCE >TCOMP UNROT
     ;
     [REPEAT]
					( P DRAPEAU RES 1ST {} P # EL )
     2DROP SWAPDROP DUPLENCOMP
     TWO #/ 
     ::
       DROP #0= NOT?SEMI
       1GETLAM %CHS 1PUTLAM 
     ;
     >TCOMP
  REPEAT
					( P DRAPEAU RES )
  DROPSWAPDROP 1GETABND			( P C S )
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME C2Pext
::
  DUPTYPELIST? NcaseTYPEERR
  DUPINCOMP ZEROSWAP
  ZERO_DO (DO)
     SWAP DUPTYPELIST? NcaseTYPEERR
     LENCOMP DUP#0=ITE SETDIMERR #+
  LOOP
						( C # )
  %0 SWAP NDUPN {}N				( C P )
  SWAPINCOMP get1 SWAP
  ZERO_DO (DO)					( CK .. C1 P )
     SWAPDUP CARCOMP >TCOMP			( ... P C1CIRC )
     INNERCOMP get1 SWAP
     ONE_DO (DO)				( CE0 CE1 ... CEK P )
        ( CEK en pos CEK-1 dans P )
        3PICK DUPTYPEREAL? NcaseTYPEERR
        %ABSCOERCE SWAP PUTLIST			( CE0 CE1 ... CEK-1 P )
     LOOP
     SWAPDROP
  LOOP
;


**********************************************************************
* Desc:
* Stack:	( grob, obj -> grob, obj )
**********************************************************************
NULLNAME PFSTEP1ext
::
  FXNDext				( grob, n, d )
  Z1 OVER
  BEGIN
  ::
    DUPTYPESYMB? NOTcase FALSETRUE
    DUPDUP LENCOMP NTHCOMPDROP EQ: x*
    NOTcase FALSETRUE			( n d d1 d2 )
    EXPR> 2DROP				( n d d1 d2.1 d2.2 )
    LVARext ROT LVARext			( n d d1 d2.2 l2 d2.1 l1 )
    ROT 2DUP EQUAL			( n d d1 d2.2 d2.1 l1 l2 l1=l2? )
    case2drop :: ROT RMULText TrueTrue ;
					( n d d1 d2.2 d2.1 l1, l2 avec l1!=l2 )
    NULLCOMP? SWAPDROP			( n d d1 d2.2 d2.1 l2={}? )
    ITE SWAPROT ROT
    RMULText SWAP FALSE
  ;
  UNTIL
					( grob, n, d, d1, d2, flag )
  NOTcase2drop :: NDXFext FALSE ;
					( grob, n, d, d1, d2 )
  4PICK "Bezout AU+BV=" >TAG XGROBext	( grob, n, d, d1, d2, grob )
  3PICK SIMPLIFY DUP "A" >TAG XGROBext
  ROTSWAP GROBADDext			( grob, n, d, d1, d2, d1, grob )
  3PICK SIMPLIFY DUP "B" >TAG XGROBext
  ROTSWAP GROBADDext			( grob, n, d, d1, d2, d1, d2, grob )
  8ROLL SWAP GROBADDext DUP SCROLLext
  7UNROLL				( grob, n, d, d1, d2, d1, d2 )
  6ROLL xABCUV EXPR> 2DROP		( grob, d, d1, d2, u, v )
  4ROLL ROTSWAP x*ext
  UNROTSWAP x*ext x+ext
  SWAPNDXF TRUE				( grob, obj, flag )
;

**********************************************************************
* Desc:
* Stack:	( grob, obj -> grob, obj )
**********************************************************************
NULLNAME PFSTEP2ext
::
  SWAPOVER DISPLAYext			( obj, grob )
  SWAPFXND				( grob, n, d )
  OVER TYPESYMB? NOTcase NDXFext
  OVERDUP LENCOMP NTHCOMPDROP
  { x+ x- } SWAP' EQ POSCOMP
  #0=case NDXFext
  SWAP EXPR> SWAPDROP
  EQ: x- IT RNEGext			( d, n1, n2 )
  SIMPLIFY 3PICK SIMPLIFY xDIV2		( d, n1, q2, r2 )
  4PICK NDXFext SIMP1ext		( d, n1, q2, r2/d )
  2SWAP SIMPLIFY OVER SIMPLIFY xDIV2	( q2, r2/d, d, q1, r1 )
  ROT NDXFext SIMPLIFY			( q2, r2/d, q1, r1/d )
  ROT x+ext				( q2, q1, res )
  UNROTSWAP x+ext SIMPLIFY		( res, q1+q2 )
  SWAP x+ext
;

**********************************************************************
* Desc:		partie recursive de la dec es simples pas a pas
* Stack:	( obj, grob -> grob, obj )
**********************************************************************
NULLNAME PFSTEP3ext
::
  OVER "Factoring" >TAG
  XGROBext GROBADDext			( obj, grob )
  SWAPFXND				( grob, n, d )
  COLCext
  ROTOVER "Deno." >TAG
  XGROBext GROBADDext			( n, d, grob )
  UNROT NDXFext				( grob, obj )
  PFSTEP1ext				( grob, obj, a_decomposer? )
  NOT?SEMI
					( grob, obj )
  PFSTEP2ext				( grob, obj )
  EXPR> SWAPDROP			( grob, obj1, obj2, op )
  ROT 4ROLL				( obj2, op, obj1, grob )
  PFSTEP3ext				( obj2, op, grob, obj1 )
  4ROLLROT PFSTEP3ext			( op, ob1, grob, ob2 )
  ROTSWAP 4ROLL EVAL			( grob, o1 op o2 )
;



**********************************************************************
* Desc:
* Stack:	( c, obj -> partie a de obj avec obj vu come un irrquad en c )
**********************************************************************
NULLNAME QREext
::
  DUPTYPECOL? NOTcase SWAPDROP
  DUPLENCOMP #2= case SWAPDROP
  QXNDext				( c, a',b',c' )
  4PICK EQUALcasedro DROP		( c, a', b', c' )
  4PICK 4ROLL QREext			( c, b', c', a'' )
  2SWAP QREext				( c', a'', b'' )
  ROT NDXQext
;

**********************************************************************
* Desc:
* Stack:	( c, obj -> partie a de obj avec obj vu come un irrquad en c )
**********************************************************************
NULLNAME QIMext
::
  DUPTYPECOL? NOTcase2drop Z0
  DUPLENCOMP #2= case2drop Z0
  QXNDext				( c, a',b',c' )
  4PICK EQUALcasedro DROP		( c, a', b', c' )
  4PICK 4ROLL QIMext			( c, b', c', a'' )
  2SWAP QIMext				( c', a'', b'' )
  ROT NDXQext
;

**********************************************************************
* Desc:
* Stack:	( P, list-irrq, p 
*		 --> P, listirrq, p, P mod p, #degre-1, #p, #facteurs, lfact )
*
* #facteurs tient compte des polynomes constants,
* ceux-ci ne sont pas repris dans la base
* calcul de la matrice de Berlekemp
* chaque ligne est par puissance decroissantes de X^degre[P]-1 a X^0 le
* coefficients de X^([degre[P]-1]p)-X^[degre[P]-1], ..., X^p-X
* suivi par X^k
* s'il y a un listirrq different de NULL{}
* on a aussi les coeff de
* irrq*(X^([degre[P]-1]p)+X^[degre[P]-1]), ..., irrq*(X^p+X)
* Cette matrice multipliee a gauche par le vecteur { a^[degre[P]-1] ... a2 a1 }
* s'annule ssi v(x)=a0 + a1 X + a2 X^2 + .. + a_deg[P]-1 X^[deg[P]-1]
* est solution de v(x)^p = v(x) mod p and P
* On reduit ensuite la matrice pour trouver une base de polynomes v(x)
**********************************************************************
NULLNAME FindBasis
::
  3PICKOVER QMODSYMext		( P, listirrq, p, P mod p )
  DUPLENCOMP #2-		( P, listirrq, p, P mod p, #degre[P]-1 )
  3PICK Z>R COERCE
  Z1 Z0
  3PICK NDUPN #1+ {}POLY	( P, listirrq, p, P mod p, #degre-1, #p, X^p )

* creation de la matrice
* ligne k=X^kp mod P and p, on retire l'identite a cette matrice

  6PICK DUPNULL{}? ITE
  DUP1LAMBIND
  ::				( P Lirq p Pmodp #deg-1 #p X^p irrq )
    Z0 4PICK #2* NDUPN
    Z2 ROTDROPSWAP		( P Lirq p Pmodp #deg-1 #p X^p irrq 0.0 2 #2p )
    get1 CARCOMP XSQRext
    DUP1LAMBIND
    SWAP#1+ []N ONE[]N
  ;
  Z1 5PICK
  #1+_ONE_DO			( P Lirq p Pmodp #deg-1 #p X^p matr X^[k-1]p )
    3PICK RMULText
    6PICK 8PICK ModDiv2 SWAPDROP

    ( P Lirq p Pmodp #deg-1 #p X^p matr, X^[k]p mod P and p )

    DUP 6PICK LRDMext

    ( P Lirq p Pmodp #deg-1 #p X^p matr, X^[k]p mod P and p, lk )

* on enleve les coefficients de X^k dans la base

    DUP ISTOP-INDEX NTHCOMPDROP
    Z1 2DUP RSUBext

    ( P Lirq p Pmodp #deg-1 #p X^p matr, X^[k]p mod P and p, lk lkk 1 lkk-1 )
    ISTOP-INDEX 5PICK PUT[]
    ( P Lirq p Pmodp #deg-1 #p X^p matr, X^[k]p mod P and p, lk lkk 1 lk' )

* s'il y a un irrquad, on doit resoudre une matrice 2 * plus large

    1GETLAM NULLCOMP? ?SKIP
    :: QREIMext top& {}POLY ;

* on rajoute le polynome X^k en fin de liste

    Z1 Z0 INDEX@ NDUPN #1+ []N
    >TCOMP 6ROLL SWAP

    ( P Lirq p Pmodp #deg-1 #p X^p, X^[k]p mod P and p, lk lkk 1 matr lk' )
    >HCOMP
    ( P Lirq p Pmodp #deg-1 #p X^p, X^[k]p mod P and p, lk lkk 1 matr )
    4UNROLL RADDext
    ( P Lirq p Pmodp #deg-1 #p X^p, X^[k]p mod P and p, matr lk lkk+1 )

* s'il y a un irrquad on decoupe la ligne en separant partie reelle et imag
* et on rajoute la ligne irrq*(X^kp-X^k)

    1GETLAM NULLCOMP?
    ::
      case2DROP
      ISTOP-INDEX ROT PUT[]

      ( P Lirq p Pmodp #deg-1 #p X^p, X^[k]p mod P and p, matr lk'' )
      QREIMext
      pshtop& {}POLY	  
      1GETLAM Z0 INDEX@ NDUPN #1+ []N
      >TCOMP
      ( P Lirq p Pmodp #deg-1 #p X^p, X^[k]p mod P and p, matr lk'' )
      >HCOMP
    ;

    ( P Lirq p Pmodp #deg-1 #p X^p, X^[k]p mod P and p, matr )
  SWAPLOOP

  ABND DROPSWAPDROP 

 ( P, listirrq, p, P mod p, #degre-1, #p, matrice )

* reduction de la matrice modulo p

 ( matrice -> matrice )

  modularflag SetSysFlag
  5PICK { LAM MODULO } BIND
  NULL{} ' 5PICK ROT INXREDext UNROT2DROP ABND
  modularflag ClrSysFlag

  ( P, listirrq, p, P mod p, #degre-1, #p, matrice )

* recherche des lignes nulles sauf dernier element -> base de solutions v(x)

  INNERCOMP ONE NULL{} ROT
  ZERO_DO (DO)			( l1, ..., ln, #elements, base )
      ROT TRIMOBJext
      ::			( l1, ..., ln-1, #elements, base, ln )
        NOTLISTcase DROP
        DUPLENCOMP
        #1=case :: &COMP SWAP#1+SWAP ;
        DROP ISTOP-INDEX DUP4UNROLL
        #2+UNROLL OVER#2+UNROL #1- NDROP
        ExitAtLOOP
      ;
  LOOP

 ( P, listirrq, p, P mod p, #degre-1, #p, #elements, base )

* #elements tient compte des polynomes constants,
* ceux-ci ne sont pas repris dans la base
* attention: les poly de la base sont donnes SANS leur coeff constant nul

* recherche des facteurs, P mod p doit etre unitaire

  ( P, listirrq, p, P mod p, #degre-1, #p, #facteurs, base )

  6PICK 1LAMBIND
  Z1 ZERO

  ( P, listirrq, p, P mod p, #degre-1, #p, #facteurs, base, i, j )

  7PICK ONE{}N
  BEGIN			( ..., #p, #facteurs, base, i, j, lfact )
     DUPLENCOMP 6PICK #<
  WHILE

* on incremente j, si j=#p alors on incremente i
* qu'on rajoute en queue du j-ieme vecteur de la base

    UNROT #1+		( ..., #p, #facteurs, base, lfact, i, j )
    5PICK OVER #=	( ..., #p, #facteurs, base, lfact, i, j, ?j=#p )
    IT
    ::
      DROP
      ( incrementation de la liste i )
      ( ...,p, P mod p, #degre-1,, #p, #facteurs, base, lfact, i )
      Z1 RADDext ONE
    ;

    ( ..., #p, #facteurs, base, lfact, i, j )
    4PICKOVER NTHCOMPDROP
    ( ..., #p, #facteurs, base, lfact, i, j, vecteur sans cste )
    3PICK RADDext
    ( ..., #p, #facteurs, base, lfact, i, j, vecteur )

* on calcule les pgcd non triviaux de vecteur avec les elements de lfact

    4ROLL
    ( ..., #p, #facteurs, base, i, j, vecteur, lfact )
    INNERCOMP get1 SWAPDUP
    ZERO_DO (DO)
        ( fact1, ..., factk, vecteur, #k )
        get1 3PICK
        ( fact2, ..., factk, vecteur, #k, fact1, vecteur )
        OVER 1GETLAM ModGcd
        ( fact2, ..., factk, vecteur, #k, fact1, pgcd )
        ::
          Z1 EQUALcasedro UNROT
          DUPUNROT 1GETLAM ModDiv2 DROP
          ( fact2, ..., factk, vecteur, #k, pgcd, fact1/pgcd )
          Z1 EQUALcasedro UNROT
          2SWAP #1+
         ;
         ( fact2, ..., factk, fact1, vecteur, #k )
    LOOP
    ( fact1, ..., factk, vecteur, #k )
    SWAPDROP {}N
    ( ..., #p, #facteurs, base, i, j, lfact )
  REPEAT
  ( P, listirrq, p, P mod p, #degre-1, #p, #facteurs, base, i, j, lfact )
  ABND
  4UNROLL3DROP
  ( P, listirrq, p, P mod p, #degre-1, #p, #facteurs, lfact )
;

**********************************************************************
* Desc:
* Stack:	( liste -> re, im en fonction de lam1 )
* Note:		irrq est en LAM1
**********************************************************************
NULLNAME QREIMext
::
  1GETLAM DUPTYPECOL? NOTcase INTERNALERR
  DUPLENCOMP #2= casedrop
     :: DUP LISTREext get1 LISTIMext ;
					( liste, irrq )
  OVER INNERCOMP get1			( liste, o1, ..., on, #n, irrq )
  SWAPDUP
  ZERO_DO (DO)				( liste, o1, ..., on, irrq, #n )
     get1 3PICKSWAP QREext UNROT
  LOOP
					( liste, o1, ..., on, irrq, #n )
  DUPUNROT #3+ ROLL
  INNERCOMP get1			( o1...on, #n, o1, .., on, #n, irrq )
  SWAPDUP
  ZERO_DO (DO)				( ..., o1, ..., on, irrq, #n )
     get1 3PICKSWAP QIMext UNROT
  LOOP
					( o1...on, #n, o1, .., on, irrq, #n )
  SWAPDROP
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME COLCMODext
::
  RCLVX VXXLext				( lvar, P )
  NOTLISTcase R2SYM
  CKPOLYSYST

* teste si square-free

  DUPDUP DERext
  RCLMODULO DUPUNROT QMODSYMext
  SWAP ModGcd				( lvar, P, pgcd[P,P'] )
  Z1 EQUALNOTcase
    :: "Not squarefree" DO$EXIT ;

* recherche 1 irrq
					( lvar, poly-liste P )
  DUP NULL{} LISTIRRQ			( lvar, P, list-irrq )
* { ZINT 2 }
  DUPNULL{}?
  ITE
    ::
      COMPLEX? NOTcase DROPZERO
      DROP Z-1 ONE
    ;
    :: CARCOMP ONE ;
  {}POLY RCLMODULO			( lvar, P, list-irrq, p )
  FindBasis

  ( lvar, P, listirrq, p, P mod p, #degre-1, #p, #facteurs, lfact )

  8UNROLL 7DROP
  ONE SWAPROT VAL2ext
  INNERCOMP DUP#1= caseDROP
  ONE_DO (DO)
     x*ext
  LOOP
;
**********************************************************************
