INCLUDE global.s
INCLUDE keydefs.h
INCLUDE erextdec.h
INCLUDE cas2extdec.h
INCLUDE erhash.h
INCLUDE erromid.h

ASSEMBLE
	NIBASC /HPHP48-D/
RPL

ASSEMBLE
WarmStart	EQU #21B4E
RPL

**********************************************************************
::
  THIRTYSIX SetSysFlag		( ecrasement xRECV )
  HOMEDIR
  ' VERNUMext ROMPTR@
  ITE
    :: VERSION% %= ;
    FALSE
  NOTcase 

  ::				( first stage )

* efface erable, kernel, ufl, minwriter et eqstk si presents

  TAG & % 787 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
  TAG & % 788 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
  TAG & % 789 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
  TAG & % 790 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
  TAG & % 791 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
  TAG & % 792 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
  TAG & % 740 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
* TAG & % 1313 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
  TAG & % 257 DUP xDETACH ERRSET xPURGE ERRTRAP DROP

* methode: si port1 present
* teste port 1

  ONE PORTSTATUS 2DROP		( present?, writeable?, merged? )
  ::
    ROT NOTcase2drop ZERO	( write?, merge? )
    casedrop ONE
    NOTcase
    ::				( teste presence du MK )
      "KERNEL" palparse NcaseSIZEERR
      TYPEIDNT? case ZERO TWO
    ;
    ONE %1 xMERGE
  ;
				( #: 0=port 0, 1=port 1, 2=port 0 mk )

* si port 0, teste qu'il est vide

  DUP#1= ITE
  ::
    xMEM % 135000 %- %0< casedrop SETMEMERR
  ;
  ::
    %0 xPVARS SWAP NULLCOMP?	( #, mem free, ?vide )
    NOTcase2drop
    :: "Empty port 0!" DO$EXIT ;
    % 90000 %-
    %0< casedrop SETMEMERR
  ;

* debut d'installation
				( # )
  displayflag SetSysFlag
  BlankDA12
  "Getting binaries"       DISPROW3
  "This will take a while" DISPROW4
  "After reboot, press"    DISPROW5
  "the VAR key, then the"  DISPROW6
  "E menu key (for SETUP)" DISPROW7

  { 
    ID UFL3.LIB
    ID EQSTK.LIB
    ( ID MINWRT12 )
    ID GXKEYS
  }

  { ID ERABLE0.LIB ID ERABLE1.LIB ID ERABLEMK.LIB }

  3PICK #1+ NTHCOMPDROP			( #, liste, id )
  DUPUNROT >HCOMP			( #, id, liste )
  xKGET					( #, id )
  "Installing binaries" DISPROW3
  TWENTYTWO Blank$ DISPROW4
  DUP@ DROPSWAP PURGE %0 xSTO		( # )

  ' ID UFL3.LIB  DUP@ DROPSWAP PURGE %0 xSTO
  ' ID EQSTK.LIB DUP@ DROPSWAP PURGE %0 xSTO
( ' ID MINWRT12  DUP@ DROPSWAP PURGE %0 xSTO )

					( # )
  #1= NOTcase
  CODE
	GOVLNG =Warmstart
  ENDCODE

* free carte en port 1

  { TAG 0 % 788 TAG 0 % 257 TAG 0 % 740 } %1 xFREE

  CODE
	GOVLNG	=Warmstart
  ENDCODE
  ;

* install stage 2

  xMEM  % 7000 %-
  DUP %0<
  case
  :: %CHS DO>STR " bytes" &$
     "Lack of " SWAP &$ FlashWarning
     DROP
  ;
  DROP'
  :: SIXTYTHREE SIXTY DO
       INDEX@ SetSysFlag
     LOOP
     xVER DROP
     xMAIN
     ROMPTR 2E4 1 ( xASTK )
  ;
  ' ID INIT STO
  "Assigning USERKeys"   DISPROW3
  "and compressing..."   DISPROW4
  "After reboot, press"  DISPROW5
  "the VAR key, then"    DISPROW6
  "the A key (for INIT)" DISPROW7

  ' ID GXKEYS DUP@ ?SKIP
  :: DUP xKGET DUP@ DROP ; 

  SWAP PURGE palparse DROP xSTOKEYS
  ' ID SETUP PURGE
  ' ID UserKeys DUP RclHiddenVar DROP
* remplace les { } par des NULL{}

  '
  :: DUPTYPELIST? NOT?SEMI
     DUPNULL{}? casedrop NULL{}
     INNERDUP ZERO_DO
        DUP #1+ROLL 1GETLAM EVAL
     SWAPLOOP
     {}N
  ;

  DUP1LAMBIND EVAL			( UserKeys, contenu )
  DUP xBYTES DROP ' ID UserKeys.CRC
  StoHiddenVar SWAP StoHiddenVar
  CODE
	GOVLNG =Warmstart
  ENDCODE
;

**********************************************************************
