INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE erextdec.h
INCLUDE erhash.h
INCLUDE keydefs.h
INCLUDE lromid.h
INCLUDE lextdec.h
INCLUDE global.s

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME LU2
::
  CK1
  DTYPENDO? NcaseSIZEERR		( endomorphisme check )
  TRANext DUP xIDENTITY x+ TRANext	( { A idn } )
  ' 5PICK XREDext			( { l u } )
  TRANext
  INNERCOMP #2/				( l1, ...ln, u1, ..., un, #n )
  DUPDUP #2+UNROLL			( l1, ..., ln, #n , u1, ..., un, #n )
  {}N TRANext OVER#2+UNROL {}N		( u, l )
  TRANext
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME RDET
::
  CK1
  DTYPENDO? NcaseTYPEERR		( endomorphism check )
  STOMAText RDEText
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME KERN
::
  CK1 AXLext
  CK&DISPATCH1
  list
    ::
      DTYPFMAT? NcaseSIZEERR
      INNERCOMP SWAP VARGENext %1 >TCOMP ROTDUP
      ZERO_DO					( l1, ..., ln, v, #n )
         get1 %0 >TCOMP
      SWAPLOOP
      {}N SWAP					( matr, lvar )
      SOLGENext
      ROTDROP ROTDROP
    ;
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME SYST
::
  CK1&Dispatch
  list :: STOSYSText
          SYSText
          SWAP ROTDROP ROTDROP
       ;
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME SOLGEN
::
  CK1&Dispatch
  list :: STOSYSText
          SOLGENext
          ROTDROP ROTDROP
       ;
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME VANDERMONDE
::
  CK1
  NOTLISTcase SETSIZEERR
  CKFPOLYext
  DUP1LAMBIND LENCOMP UNCOERCE
  DUP'
    :: 2DROP
       4GETLAM INDEX@ #1+ NTHCOMPDROP
       JINDEX@ UNCOERCE SYM^
    ;
  LCXMext
  ABND
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME HILBERT
::
  CK1
  CK1Z Z>R
  DUP'
    :: %+ %1 DUPUNROT %- NDXFext ;
  LCXMext
;

**********************************************************************
* Desc:
* Stack:	( L,C, prg -> matrice )
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME LCXM
::
  CK3&Dispatch
  # 118  LCXMext
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
	CON(3)	000
RPL
xNAME STUDMULT
::
  CK2&Dispatch
  any :: CK2FPOLY
         RESOROMP RMULText
         ASOPext
      ;
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME GAUSS
::
  CK1 GAUSSext
;

**********************************************************************
* Desc:
* Stack:	( symb -> lvar, matrice )
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME QXA
::
  CK1&Dispatch
  symb :: QXAext				( matr, lvar )
          TWO ROT				( lvar, #2, matr )
          NULL{} VAL2ext SWAP			( matr, lvar )
       ;
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME AXQ
::
  CK1
  DTYPENDO?
  ITE
     VARGENext
     :: CK2NOLASTWD			        ( endo, lvar )
        SWAP DTYPENDO? NcaseTYPEERR	        ( lvar, endo )
        DUPLENCOMP ROT DUPLENCOMP
        ROT #= NcaseTYPEERR
     ;
						( endo, lvar )
  SWAP Z2 MPMULText
  INNERCOMP DUP1LAMBIND NULL{} SWAP
  ZERO_DO (DO)			        ( ln, ..., lk, {lk-1, ..., l1} )
      SWAPINCOMP DROP
      INDEX@ NDROPH
      Z2 RDIVext
      Z0 INDEX@ NDUPN DROP
      1GETLAM {}N >HCOMP
  LOOP
  ABND
  OVER
  NOSIMPEVALext :: MVMULText XYext ;
  SIMP1ext
;

**********************************************************************
* Desc:
* Stack:	( matrice, linconnues -->
*		linconnues, linconnues rearrangee, resultat, cas particulier )
**********************************************************************
NULLNAME SYSText
::
  NULL{} VXXLext SWAPDROP 
  SWAPONE TOLISText			( linconnues, lvar, matrice )
  ONESWAP INXREDext			( linconnues, lvar, lpivot, matrice )
  4ROLL UNROTDUP		( lvar, linconnues, lpivot, matrice, matrice )

  NULLNAME MDIAGext
  :: INNERDUP #1-SWAP
     #1+_ONE_DO
         get1 INDEX@ NTHCOMPDROP
     SWAPLOOP
     #1+ {}N
  ;
				( lvar linconnues lpivot matrice lcoefdiag )
  ROT &COMP			( lvar, linconnues, matrice, caspart )
  UNROT				( lvar, lpivot, linconnues, matrice reduite )

  ( supprime les lignes nulles )

  INNERCOMP
  BEGIN
     OVER TRIMOBJext Z0 EQUAL
  WHILE
     SWAPDROP #1-
  REPEAT
  {}N				( lvar, lpivot, linconnues,, matrice reduite )
  OVER >TCOMP			( lvar, lpivot, linconnues, matrice reduite )
  DUPLENCOMP 3PICK LENCOMP SWAPROT	( lpivot, linconnues, #col, #lig, mat )

  ( effectue des rotations de colonnes si necessaire )

  ONEONE
  BEGIN		( lvar lpivot linconnues #col #lig mat #actcol #actlig )
     OVER 6PICK #< OVER 6PICK #< AND
  WHILE		( lvar lpivot linconnues #col #lig mat #actcol #actlig )
     3PICKOVER NTHCOMPDROP
     3PICK NTHCOMPDROP
     TRIMOBJext Z0 EQUAL

     ( teste si le coef #actcol, #actlign de matr est nul )
     ( s'il est nul, echange la colonne avec la derniere )
     ( colonne de la matrice )

     IT :: OVER 4ROLLSWAP ( EXC )
           SWAPINCOMP
           get1 3PICK LENCOMP SWAP#- #2+
           1LAMBIND			           ( l1, ..., ln, #n )
           DUP#1+ SWAP
           ZERO_DO	                   ( lk, ..., ln, l1, ..., lk-1, #n+1 )
               DUPROLL INNERCOMP
               1GETLAM ROLLSWAP {}N
           SWAPLOOP
           #1-{}N ABND ( end of EXC )
           UNROT
        ;
     #1+SWAP #1+SWAP
  REPEAT

  2DROP UNROT2DROP

  ( caspart, linconnues, matr reduite arrangee )

  INNERCOMP NULL{} SWAP
  ONE_DO (DO)		       ( ..., m1, ..., mk, linconnues, { equations }  )
       OVER 4ROLL  ( LXE )
       TRIMext DUP CDRCOMP DUPNULL{}?
       ITE :: ROT2DROP CARCOMP Z0 ;
           :: SWAP CARCOMP RESOROMP RDIVext LOP1ext
              ( stk = liste var, coefficients )
              SWAP DUPLENCOMP DUP 4PICK LENCOMP #-SWAP SUBCOMP
              ( stk = coeff. ,liste var tronquee )
              DUP CARCOMP UNROT CDRCOMP RNEGext
              ( var principale, coeff, var aux )
              XYext
           ;
       SWAP
       HSECO2RCext
       DO>STR >TAG ( end of LXE )
       >TCOMP
  LOOP
  INNERCOMP reversym {}N
  ( lvar caspart linconnues linconnues_arrangee, liste de resultats taggues )
  4ROLL
  ( lvar linconnues linconnues_arrangee, liset_result_tagged cas_particuliers )
  ONEONE 2DUP FOUR {}N FROMLISText
  "Specific" >TAG
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME SOLGENext
::
  SYSText	( lvar, lvar arrangee, liste de resultats taggues, cas part )
  4UNROLL

  ( supprime la partie constante de la liste de variables )

  3PICK DUPLENCOMP #1- ONESWAP SUBCOMP

  ( caspart, lvar, lvar arrangee, { var taggues }, lvar tronquee )
  ( dans chaque equation, lire si le tag est dans la liste des variables )
  ( si oui, remplacer dans lvar le tag par son equation )
  ( si non, ajouter aux equations de compatibilite )

  NULL{} 3PICK DUPLENCOMP

  ( stk= ..., lvar tr, { compatibilite }, { var taggues } ,#eq )

  4PICK SWAP#1+
  ONE_DO (DO)
      ( lvar tr, { compatibilite } { var taggues }, lvar mod )
      OVERINDEX@ NTHCOMPDROP xOBJ\-> xSTR\->
      ( lvar tr, {comp}, {eq}, lvar mod, valeur, variable )
      3PICKOVER EQUALPOSCOMP ( ..., position ou #0 si non trouv )
      DUP#0=ITE
        :: DROP EXPR= 4ROLLSWAP >TCOMP UNROT ;
	:: SWAPDROP ROT PUTLIST ; 
  LOOP
  SWAPDROP

  ( caspart, lvar, lvar arrangee, { var }, lvar tr, {comp}, lvar mod )

  SWAP DO>STR "If " SWAP &$  ", " &$ ROT DO>STR &$ "=" &$ >TAG

  ( lpivot, lvar, lvar arrangee, { var }, lvar tr, {comp}, lvar mod )
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME STOSYSText
::
  CKFPOLYext
  DUPINCOMP OVER TYPELIST? 
  ITE :: #1-SWAP LVARext SWAPDROPSWAP ;
      :: DUP #2+PICK LVARext		( syst, eq1, .., eqn, #n, syst, lvar )
         SWAPDROPSWAP
      ;
					( syst, eq1, ..., eqn, inconnues, #eq )
  DUPUNROT #2+UNROLL			( syst, inconnues, eq1, ..., eqn, #eq )
  DUP#1= ITE
    :: DROP NOTLISTcase ONE{}N ; 
    {}N 
					( syst, inconnues, { eqns } )
  SWAP MAKESYSText NcaseSIZEERR		( syst, equations, matrice, lidnt )
  ROTDROPSWAP LVARext ROTSWAP		( syst, matrice, lidnt )
  LENCOMP #0=?SEMI
  3PICK ' ID SYSTEM STO
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME RDEText
::
  ONE TOLISText
  ' 5PICK SWAP INXREDext			( lvar, lpivot, matr )
  ::
    INNERCOMP reversym
    SWAP CARCOMP SWAP
    #1+DUP #2= caseDROP
    TWO DO
       SWAPINDEX@ NTHCOMPDROP x*ext
    LOOP
  ;
						( lvar, lpivot, numerateur )
  ::
    SWAPINCOMP
    DUP#0=csedrp %1
    %1 SWAP #2/
    ZERO_DO (DO)
       UNROT x^ext x*ext
    LOOP
  ;

  NDXFext					( lvar, determinant )
  ZEROSWAP ROT VALOBJext 
;

**********************************************************************
* Desc:
* Stack:	( { poly2 } { poly1 } oprateur binaire --> { poly3 } )
**********************************************************************
NULLNAME ASOPext
::
  '
  :: ( LAM 4 list, o -> )
     DUPTYPESYMB? case 2GETEVAL
     SWAPINCOMP DUP#0= caseDROP
     get1 ROTSWAP 1GETLAM EVAL EVAL SWAP {}N
  ;
  '
  :: ( LAM 3 list A, list B -> listA peut etre un objet non liste )
     OVER TYPESYMB? case 2GETEVAL
     SWAP DUPTYPELIST? ITE INNERCOMP ONE
     DUP#0= caseDROP
     get1
     INNERCOMP
     DUP#0= casedrop {}N
     get1				( a1..aa b1...bb #b #a )
     SWAP2DUP #MIN SWAP#1+SWAP		( a1..aa b1...bb #a #b+1 #min )
     ZERO_DO (DO)			( a1..ak ck+1..cb b1..bk #a #b+1 )
        get1
        4ROLL 1GETLAM EVAL EVAL
        OVER #1+UNROLL
     LOOP

     ( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a, #b+1 )
     ( si #a>=#b: a1,..., a[a-b], c[a-b]+1,...,ca, #a, #b+1 )
     ( si #a<#b, il faut continuer avec %0 comme oprande )

     #1- 2DUP#< NOTcasedrop ( #b=#a ) {}N

				( #a < #b : c[b-a]+1...,ca b1...b[b-a] #a #b )
     DUPROT #-			( c[b-a]+1,...,ca, b1,...,b[b-a], #b, #b-a )
     ZERO_DO (DO)		( ck+1,...,ca, b1,...,bk, #b )
        Z0
        ROT 1GETLAM EVAL EVAL
        OVER #1+UNROLL
     LOOP
     {}N
  ;
  '
  :: ( LAM1 prg principal o, o -> )
     CK&DISPATCH1
     FIVE   3GETLAM
     EIGHTY 4GETLAM
     ZERO   2GETLAM
  ;

  4ROLLSWAP ( LAM2: oprateur binaire )
  4NULLLAM{} BIND 
  1GETLAM EVAL EVAL
  ABND
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME QXAext
::
  DUPTYPESYMB? ITE
    :: LVARext VXXLext ; 
    :: CK2NOLASTWD OVER TYPESYMB? NcaseSIZEERR VXXLext ; 

  TRIMext OVER LENCOMP			( lvar, quadr-list, #lvar=LAM4 )

  '
  :: ( LAM3 objet -> objet dlist )
     BEGIN
       DUPTYPELIST?
     WHILE
       DUPLENCOMP #1= NcaseSIZEERR CARCOMP
     REPEAT
  ;

  '
  :: ( LAM2 liste, # -> liste de longueur # )
     SWAP DUPTYPELIST? ?SKIP ONE{}N
     DUPUNROT LENCOMP 2DUP#<
     ( liste, #, longueur de liste , ?#<longueur de liste)
     caseSIZEERR
     #- Z0 SWAP NDUPN {}N SWAP &COMP
  ;

  '
  :: ( LAM1 algebrique quadratique -> matrice )
						( { A, 'BY+CZ', reste } )
     THREE 2GETEVAL
     INCOMPDROP					(  A, 'BY+CZ', reste )
     4GETLAM DUP#1- 4PUTLAM
     #1=case :: Z0 EQUAL NcaseSIZEERR
                Z0 EQUAL NcaseSIZEERR
                Z2 RMULText ONE{}N ONE{}N
             ;
     1GETLAM EVAL
     DUPUNROT LENCOMP			( A, matrice, 'BY+CZ', longueur )
     DUPUNROT
     ZERO_DO (DO)			( coef1,..., coefk, #n, lineaire )
        DUPTYPELIST? ?SKIP ONE{}N
        TWO 2GETEVAL
        INCOMPDROP			( coef1...coefk #n coefk+1 lineaire )
        SWAP 3GETLAM EVAL
        UNROT
     LOOP
     Z0 EQUAL NcaseSIZEERR {}N
					( A, matrice, liste )
     DUPROT				( A, liste, liste, matrice )
     TRANext SWAP>HCOMP			( A, liste, matrice )
     TRANext UNROTSWAP
     3GETLAM EVAL
     Z2 RMULText
     >HCOMP >HCOMP
  ;
					( lvar, quadr-list, prg )
  4NULLLAM{} BIND
  1GETLAM EVAL
  ABND
					( lvar, matrice-list )
  QOBJext
  :: Z2 RDIVext ;
  SWAP					( matrice, lvar )       
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME GAUSSext
::
  DTYPENDO?
  ITE
    TRUE
    :: xQXA				( matr-liste, lvar )
       OVER				( matr-liste, lvar, matr-liste )
       FALSE
    ;
  SWAPONE				( flag, matr-liste, #1 )
  TOLISText
  '
  ::
     DUPLENCOMP #1=case
        :: INCOMPDROP { { ZINT 1 } } ;
     DUP Z0 MPMULText
     OVER EQUALcase
        :: DUP CARCOMP SWAP ;
     DUPINCOMP reversym
     DUP#1+ TRUE SWAP			( A, l1,...,ln,#n,true, #n+1 )
     ONE_DO (DO)
        ROT INDEX@ NTHCOMPDROP
        TRIMOBJext
        Z0 EQUAL AND			( A, l1, ..., lk, #n, boolean )
        ITE
           TRUE
           :: INDEX@#- NDROP
              INDEX@ ExitAtLOOP
              FALSE
           ;
     LOOP
					( A, #k, false ou A, #n, true )
     case
       :: ( aucun carr trouv )
          UNCOERCE xIDN AXLext
          DUPUNROT			( I, A, I )
          { { ZINT 0 }
            { ZINT -1 ZINT 0 }
          }
          RADDext
          DUPUNROT TRANext
          MMULText MMULText
          1GETLAM EVAL			( I, D, P )
          ROT
          real_intflag UserITE
          { { SYMBOL ZINT -1 ZINT 2 x/ ;
              SYMBOL ZINT 1 ZINT 2 x/ ;
            }
            { SYMBOL ZINT -1 ZINT 2 x/ ;
              SYMBOL ZINT -1 ZINT 2 x/ ;
            }
          }
          { { %% -.5 %%.5 }
            { %% -.5 %% -.5 }
          }
          RADDext MMULText
       ;
						( A, #k )
     2DUP NTHCOMPDROP				( A, #k, lk )
     DUP3PICK NTHCOMPDROP 4PICK LENCOMP		( A, #k, lk, akk, #n )
						( LAM 4   3   2   1  )
     4NULLLAM{} BIND

     INNERCOMP reversym DROP
     4GETLAM ROLLDROP NULL{}		( ln...lk+1, lk-1...l1  {} )
     1GETLAM
     ONE_DO (DO)			( ln...lk+1 lk-1...lr {l1,...} )
        SWAPINCOMP reversym
        4GETLAM #1+ ROLLDROP		( {l1...} anr...ak+1r ak-1r...a1r #n )
        3GETLAM INDEX@ DUP#1+
        4GETLAM #> IT #1+
        NTHCOMPDROP NULL{} ROT		( anr...ak+1r ak-1r...a1r arr {} #n )
        ONE_DO (DO)
          ROT 3PICK 3GETLAM
          INDEX@ DUP#1+ 4GETLAM #> IT #1+
          NTHCOMPDROP RMULText
          2GETLAM RDIVext RSUBext
          >TCOMP
        LOOP
        SWAPDROP >TCOMP
     LOOP
     4GETLAM 3GETLAM OVER Z1 2GETLAM RDIVext
     ABND
     5ROLL 1GETLAM EVAL			( #k, lk, #k, 1/akk , D, P)
     4UNROLL

     ( rajoute stk2 en stk3-ime position de stk1 )

     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N

     ( fin de routine )

     4UNROLL				( D, #k, lk, P )
     TRANext
     DUPLENCOMP 4PICK Z0 ROT NDUPN
     {}N ROT				( D, #k, lk, #k, {%0}, P )
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N TRANext
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N
  ;

  DUP1LAMBIND EVAL ABND		( [matr-liste lvar] flag_list_input lvar D P )
  { ONE TWO } FROMLISText
  ROT ?SEMI			( matr-liste, lvar, D, P )
  2DUP 5PICK			( matr-liste, lvar, D, P, D, P, lvar )
  SWAPINCOMP get1 NULL{} ROT
  ZERO_DO (DO)
     OVER 4ROLL ( XYext )
     INNERCOMP #1+ROLL INNERCOMP
     DUP#1= casedrop x*
     get1			( y1...yn-1, x1...xn, #n, yn )
     ROT x*			( y1...yn-1, x1...xn-1, #n, xn*yn )
     SWAPDUP
     ONE_DO (DO)		( y1...yn-k, x1...xn-k, x.y, #n-k+1 )
        get1			( y1...yn-k-1, x1...xn-k, x.y, #n-k+1, yn-k )
        ROTSWAP			( y1...yn-k-1, x1...xn-k, #n-k+1, x.y, yn-k )
        4ROLL			( y1...yn-k-1, x1...#n-k+1, x.y, yn-k, xn-k )
        x* x+ SWAP#1-
     LOOP
				( X.Y, # )
     DROP  ( end of XYext )
     >HCOMP
  LOOP
  SWAPDROP			( matr-liste, lvar, D, P, D, Dxyz )
  INNERCOMP #1+ROLL INNERCOMP
  DUP #3+ %0 ROT
  ZERO_DO (DO)
     ROT 3PICK PICK %2 x^ x* x+
  LOOP
  OVER #1- UNROLL #3- NDROP	( matr-liste, lvar, D, P, symb )
  5UNROLL 2SWAP 5ROLL		( D, P, matr-liste, lvar, symb )
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME LCXMext
::	
  UNROT %ABSCOERCE 
  DUP#0=case SETTYPEERR
  SWAP %ABSCOERCE
  DUP#0=case SETTYPEERR
  UNROT ' NULLLAM DUPTWO DOBIND
  DUP#0_DO
     1GETLAM 
     DUP#0_DO
        DEPTH
        JINDEX@ #1+ UNCOERCE
        INDEX@ #1+ UNCOERCE
        2GETEVAL
        DEPTH ROT #2+
        #<>case SETTYPEERR
     SWAPLOOP
     {}N 
  SWAPLOOP
  {}N
  ABND
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME MAKESYSText
::
					( { symb }, lidnt )
  DUPNULL{}? caseSIZEERR
  LIDNTLVAR				( { symb }, lidnt, lvar )
  3PICKSWAP VXXLext			( { symb }, lidnt, lvar, { symb-l } )
  TRUE 1LAMBIND
  ZERO 4ROLLROT			( { symb }, lvar, metares, lidnt, { symb-l } )
  DUPLENCOMP
  #1+_ONE_DO (DO)
     DUPINDEX@ NTHCOMPDROP FXNDext DROP
     ( l-symb; lvar; metares, lidnt, { symb-l }, num )
     NULL{} SWAP4PICK LENCOMP
     ZERO_DO
	( l-symb; lvar; metares, lidnt, { symb-l}, res; num )
	::
          NOTLISTcase Z0
          DUPLENCOMP DUP#1= casedrop
            :: CARCOMP Z0 ;
          #>2case
            :: ExitAtLOOP FalseFalse 1PUTLAM ;
          INCOMPDROP SWAP
          ISTOP-INDEX DUP#1= caseDROP
          ONE_DO (DO)
             DUPTYPELIST?
             ITE
                :: DUPLENCOMP #1= case CARCOMP
                   ExitAtLOOP
                   FALSE 1PUTLAM
                ;
                ExitAtLOOP   	      
          LOOP
        ;
        ROTSWAP >TCOMP
    SWAPLOOP

			( l-symb; lvar; metares, lidnt, {symb-l}, res; num )
    >TCOMP		( l-symb; lvar; metares, lidnt, {symb-l}, res )
    4UNROLL
    ROT #1+ UNROT		( l-symb; lvar; metares, lidnt, {symb-l} )
    1GETLAM ?SKIP ExitAtLOOP	( l-symb; lvar; metares, lidnt, {symb-l} )
  LOOP

  DROP OVER#2+UNROL {}N		( l-symb; lvar; lidnt, res )
  TWO SWAP4ROLL
  4PICK LENCOMP #1+
  MINUSONE SUBCOMP		( l-symb, lidnt, res, #2, lvar' )
  VAL2ext SWAP			( l-symb, res, lidnt )
  %1 >TCOMP
  1GETABND			( l-symb, res, lidnt, flag )
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME VARGENext
::
  DUPLENCOMP DUP
  #1+_ONE_DO		( x1, ..., xr, #n )
    "x"
    INDEX@ UNCOERCE DO>STR &$
    $>ID
  SWAPLOOP
  {}N
;

**********************************************************************
* Configuration object
**********************************************************************
ASSEMBLE
=lincfg
RPL
::
  [#] LROMID XEQSETLIB 		( autoattach )
;

**********************************************************************
